package myfirstgui;

import java.awt.Color;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import java.awt.datatransfer.*;
import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JFrame;

public class DisplayText extends MyJFrame implements ClipboardOwner {

    public DisplayText(String fileName, String fileContents) {
        this.fileName = fileName;
        this.fileContents = fileContents;
        initComponents();
    }

    private void initComponents() {
        selectedText = "";
        container = new JPanel();
        container.setBackground(Color.white);
        textEditorPane = new JTextArea();
        textEditorPane.setBorder(null);
        textEditorPane.setText(fileContents);
        textEditorPane.addMouseListener(new MouseListener() {

            @Override
            public void mouseClicked(MouseEvent e) {
                if (!selectedText.isEmpty()) {
                    insertText(selectedText, textEditorPane.getSelectionEnd());
                } else {
                    return;
                }
            }

            @Override
            public void mousePressed(MouseEvent e) {
            }

            @Override
            public void mouseReleased(MouseEvent e) {
                selectText();
            }

            @Override
            public void mouseEntered(MouseEvent e) {
            }

            @Override
            public void mouseExited(MouseEvent e) {
            }

        });

        //Copy submenu item
        subMenuItem1.addActionListener(new ActionListener() {

            @Override
            public void actionPerformed(ActionEvent e) {
                StringSelection stringSelection = new StringSelection(selectedText);
                clpbrd.setContents(stringSelection, DisplayText.this);
                try {
                    System.out.println("Text selected ... " + selectedText);
                    System.out.println("Text copied ... " + stringSelection.getTransferData(DataFlavor.stringFlavor));
                } catch (UnsupportedFlavorException ex) {
                    Logger.getLogger(DisplayText.class.getName()).log(Level.SEVERE, null, ex);
                } catch (IOException ex) {
                    Logger.getLogger(DisplayText.class.getName()).log(Level.SEVERE, null, ex);
                }
            }
        });

        //Paste submenu item
        subMenuItem2.addActionListener(new ActionListener() {

            @Override
            public void actionPerformed(ActionEvent e) {
                try {
                    String contents = (String) clpbrd.getData(DataFlavor.stringFlavor);
                    System.out.println("Text from clipboard ... " + contents);
                } catch (UnsupportedFlavorException ex) {
                    Logger.getLogger(DisplayText.class.getName()).log(Level.SEVERE, null, ex);
                } catch (IOException ex) {
                    Logger.getLogger(DisplayText.class.getName()).log(Level.SEVERE, null, ex);
                }
            }
        });

        container.add(textEditorPane);
        scrollable = new JScrollPane(container);
        pack();
    }

    private void selectText() {
        if (textEditorPane.getSelectedText() != null) {
            selectedText = textEditorPane.getSelectedText();
        }
    }

    private void insertText(String text, int position) {
        textEditorPane.insert(text, position);
    }

    public void init() {
        setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
        setContentPane(scrollable);
        setTitle("New File");
        setVisible(true);
    }

    private String fileName;
    private String fileContents;
    private JTextArea textEditorPane;
    private JPanel container;
    private JScrollPane scrollable;
    String selectedText;

    @Override
    public void lostOwnership(Clipboard clipboard, Transferable contents) {

    }
}
