
package myfirstgui;

import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import javax.swing.JFrame;
import javax.swing.JPanel;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Polygon;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;

public class MyGraphics extends JFrame {

    private Polygon pol;

    public MyGraphics() {
        initCompnents();
    }

    private void initCompnents() {
        setTitle("Smile White Board");
        container = new PolygonPanel();
        container.setBackground(Color.white);
        pack();
    }

    public void init() {
        setContentPane(container);
        setSize(600, 600);
        setVisible(true);
    }

    private PolygonPanel container;

    private class PolygonPanel extends JPanel implements MouseListener, MouseMotionListener {

        private Polygon star;
        private Polygon house;

        int x;
        int y;
        int posX;
        int posY;

        public PolygonPanel() {
            addMouseListener(this);
            addMouseMotionListener(this);
        }

        @Override
        public Dimension getPreferredSize() {
            return new Dimension(200, 200);
        }

        @Override
        protected void paintComponent(Graphics g) {
            super.paintComponent(g);
            int xPoly[] = {0, 80, 0, 100, 150, 200, 320, 240, 300, 150};
            int yPoly[] = {300, 160, 100, 100, 0, 100, 100, 160, 300, 200};

            int houseX[] = {10, 10, 160, 310, 310};
            int houseY[] = {550, 450, 350, 450, 550};

            star = new Polygon(xPoly, yPoly, xPoly.length);
            g.setColor(Color.YELLOW);
            g.fillPolygon(star);
            g.drawPolygon(star);

            house = new Polygon(houseX, houseY, houseX.length);
            g.setColor(Color.MAGENTA);
            g.fillPolygon(house);
            g.drawPolygon(house);

            g.setColor(Color.WHITE);
            g.fillRect(110, 500, 70, 60);

           
            Font font = new Font("My house", 1, 11);
            g.setColor(Color.BLACK);
            g.setFont(font);
        }

        @Override
        public void mouseClicked(MouseEvent e) {

        }

        @Override
        public void mousePressed(MouseEvent me) {
            posX = me.getX();
            posY = me.getY();
        }

        @Override
        public void mouseReleased(MouseEvent e) {

        }

        @Override
        public void mouseEntered(MouseEvent e) {

        }

        @Override
        public void mouseExited(MouseEvent e) {

        }

        @Override
        public void mouseDragged(MouseEvent me) {
            Graphics g = getGraphics();
            Graphics2D g2 = (Graphics2D) g;
            g2.setStroke(new BasicStroke(10));
            g2.setColor(Color.BLUE);
            g2.drawLine(posX, posY, me.getX(), me.getY());
            posX = me.getX();
            posY = me.getY();
        }

        @Override
        public void mouseMoved(MouseEvent e) {

        }

    }

}
