package myfirstgui;

import java.awt.Color;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Rectangle;
import java.awt.Toolkit;
import java.awt.datatransfer.Clipboard;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.io.File;
import java.io.IOException;
import java.nio.charset.Charset;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;

public class MyJFrame extends JFrame {

    /**
     * Creates new form MyJFrame
     */
    public MyJFrame() {
        setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
        initComponents();
    }

    @SuppressWarnings("unchecked")
    private void initComponents() {
        constraints = new GridBagConstraints();
        browse = new JButton("Browser");
        close = new JButton("Close");
        drawing = new JButton("Drawing");
        String path = new File("src/resources/download.jpg").getAbsolutePath();
        image = new ImageIcon(path);
        imageContainer = new JButton(image);
        imageContainer.addActionListener(new ActionListener() {

            @Override
            public void actionPerformed(ActionEvent e) {
                MyGraphics graphics = new MyGraphics();
                graphics.init();
            }
        });

        clpbrd = Toolkit.getDefaultToolkit().getSystemClipboard();

        browserWindow = new Browser();
        container = new JPanel();
        container.setLayout(new GridBagLayout());
        container.setBackground(Color.white);

        jMenuItem9 = new javax.swing.JMenuItem();
        jMenuBar1 = new javax.swing.JMenuBar();
        jMenu1 = new javax.swing.JMenu();
        jMenuItem1 = new javax.swing.JMenuItem();
        jMenuItem2 = new javax.swing.JMenuItem();
        jSeparator3 = new javax.swing.JPopupMenu.Separator();
        jMenuItem3 = new javax.swing.JMenuItem();
        jSeparator2 = new javax.swing.JPopupMenu.Separator();
        jMenuItem4 = new javax.swing.JMenuItem();
        jMenu2 = new javax.swing.JMenu();
        subMenuItem1 = new JMenuItem("Copy");

        subMenuItem2 = new JMenuItem("Paste");
        subMenu = new JMenu("Edit");
        jMenuItem5 = new javax.swing.JMenuItem();
        jMenuItem6 = new javax.swing.JMenuItem();
        jMenu3 = new javax.swing.JMenu();
        jMenuItem8 = new javax.swing.JMenuItem();

        jMenuItem9.setText("");

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("My First GUI 2004");

        jMenu1.setText("File");

        jMenuItem1.setText("New");
        jMenuItem1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem1ActionPerformed(evt);
            }
        });
        jMenu1.add(jMenuItem1);

        jMenuItem2.setText("List Files");
        jMenuItem2.addActionListener(new ActionListener() {

            @Override
            public void actionPerformed(ActionEvent e) {
                JFileChooser fc = new JFileChooser();
                if (e.getSource() == jMenuItem2) {
                    int returnVal = fc.showOpenDialog(MyJFrame.this);

                    if (returnVal == JFileChooser.APPROVE_OPTION) {
                        try {
                            File file = fc.getSelectedFile();
                            String contents = readFile(file.getPath(), Charset.defaultCharset());
                            DisplayText display = new DisplayText(file.getPath(), contents);
                            display.init();
                        } catch (IOException ex) {
                            Logger.getLogger(MyJFrame.class.getName()).log(Level.SEVERE, null, ex);
                        }
                    } else {
                    }
                }
            }
        });
        jMenu1.add(jMenuItem2);
        jMenu1.add(jSeparator3);

        jMenuItem3.setText("Save As");
        jMenu1.add(jMenuItem3);
        jMenu1.add(jSeparator2);

        jMenuItem4.setText("Close");
        jMenu1.add(jMenuItem4);

        jMenuBar1.add(jMenu1);

        jMenu2.setText("Tool");

        jMenuItem5.setText("Sort");
        jMenu2.add(jMenuItem5);

        jMenuItem6.setText("Search");
        jMenu2.add(jMenuItem6);

        subMenu.add(subMenuItem1);
        subMenu.add(subMenuItem2);
        jMenu2.add(subMenu);

        jMenuBar1.add(jMenu2);

        jMenu3.setText("Help");

        jMenuItem8.setText("jMenuItem8");
        jMenu3.add(jMenuItem8);

        jMenuBar1.add(jMenu3);

        setJMenuBar(jMenuBar1);

        constraints.gridx = 0;
        constraints.gridy = 0;
        constraints.insets.set(0, 40, 0, 150);
        container.add(drawing, constraints);

        constraints.gridx = 2;
        constraints.gridy = 0;
        close.addActionListener(new ActionListener() {

            @Override
            public void actionPerformed(ActionEvent e) {
                //JOptionPane.showMessageDialog(MyJFrame.this, "The window is closing","COP3337",JOptionPane.INFORMATION_MESSAGE);
                MyJFrame.this.dispose();
            }
        });

        container.add(close, constraints);

        constraints.gridx = 0;
        constraints.gridy = 1;
        constraints.insets.set(50, 255, 50, 150);
        container.add(imageContainer, constraints);

        constraints.gridx = 0;
        constraints.gridy = 2;
        constraints.insets.set(0, 125, 0, 125);
        constraints.fill = GridBagConstraints.HORIZONTAL;
        constraints.gridwidth = 3;
        browse.addActionListener(new ActionListener() {

            @Override
            public void actionPerformed(ActionEvent e) {
                browserWindow.init();
            }
        });
        container.add(browse, constraints);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
                layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGap(0, 400, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
                layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGap(0, 281, Short.MAX_VALUE)
        );
        this.addWindowListener(windowListerner);
        pack();
    }

    private void jMenuItem1ActionPerformed(java.awt.event.ActionEvent evt) {
        System.out.println(evt.getActionCommand() + " action is performed");
        DisplayText display = new DisplayText("filename", "");
        display.init();
    }

    static String readFile(String path, Charset encoding)
            throws IOException {
        byte[] encoded = Files.readAllBytes(Paths.get(path));
        return new String(encoded, encoding);
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(MyJFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(MyJFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(MyJFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(MyJFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                mainFrame = new MyJFrame();
                mainFrame.setBounds(new Rectangle(800, 500));
                mainFrame.setContentPane(container);
                mainFrame.setVisible(true);
            }
        });
    }
    private JMenu subMenu;
    public JMenuItem subMenuItem1, subMenuItem2;
    public Clipboard clpbrd;
    private javax.swing.JMenu jMenu1;
    private javax.swing.JMenu jMenu2;
    private javax.swing.JMenu jMenu3;
    private javax.swing.JMenuBar jMenuBar1;
    private javax.swing.JMenuItem jMenuItem1;
    private javax.swing.JMenuItem jMenuItem2;
    private javax.swing.JMenuItem jMenuItem3;
    private javax.swing.JMenuItem jMenuItem4;
    private javax.swing.JMenuItem jMenuItem5;
    private javax.swing.JMenuItem jMenuItem6;
    private javax.swing.JMenuItem jMenuItem8;
    private javax.swing.JMenuItem jMenuItem9;
    private javax.swing.JPopupMenu.Separator jSeparator2;
    private javax.swing.JPopupMenu.Separator jSeparator3;
    private static JPanel container;
    private static Browser browserWindow;
    private JButton drawing;
    private JButton browse;
    private JButton close;
    private ImageIcon image;
    private JButton imageContainer;
    private GridBagConstraints constraints;
    private static MyJFrame mainFrame;

    private WindowListener windowListerner = new WindowListener() {
        private JFrame frame = new JFrame();

        @Override
        public void windowOpened(WindowEvent e) {
        }

        @Override
        public void windowClosing(WindowEvent e) {
            System.out.println("Wondow closing ...");
        }

        @Override
        public void windowClosed(WindowEvent e) {
            System.out.println("Wondow closed ...");
           JOptionPane.showMessageDialog(frame, "The window is closing","COP3337",JOptionPane.INFORMATION_MESSAGE);
           System.out.println("Acknoledgement received ...");
           System.exit(0);
        }

        @Override
        public void windowIconified(WindowEvent e) {

        }

        @Override
        public void windowDeiconified(WindowEvent e) {
        }

        @Override
        public void windowActivated(WindowEvent e) {
        }

        @Override
        public void windowDeactivated(WindowEvent e) {
        }
    };

}
